
function [u] = getControl(x_est, x_s, u_s, A, B, Q, R, N)

    [nx, nu] = size(B);

    % Define Aeq (see documentation of fmincon)
    Aeq = zeros(N*nx, N*(nx+nu));
    Aeq(1:nx,1:nx) = eye(nx);
    
    for i = 1:N-1
        Aeq(i*(nx)+1 : i*(nx)+nx, (i-1)*(nx+nu)+1:i*(nx+nu)+nx) = [A,B,-eye(nx)];
    end
    size(Aeq)
    Z0 = zeros(N*(nx+nu),1);
    beq = zeros(N*nx,1);
    beq(1:nx) = x_est - x_s;

    %solve problem
    options = optimoptions('fmincon','Display','iter','Algorithm','active-set');
    z_opt = fmincon(@(Z) cost_regulator(Z, Q, R, N),Z0,[],[],Aeq,beq,[],[],[],options);
    
    u = z_opt(nx+1:nx+nu, 1) + u_s;
    
end
