function [x_s, u_s] = getSteadyState(A, B, C, Q_s, R_s, y_ref, H, r_ref)

    [nx, nu] = size(B);
    ny = size(y_ref, 1);
    nc = size(r_ref, 1);

    % Define Aeq (see documentation of fmincon)
    Aeq = zeros(nx+nc, nx+nu);
    
    beq = zeros(nx+nc,1);
    
    Aeq(1:nx, 1:nx) = eye(nx)-A;
    Aeq(1:nx, nx+1:nx+nu) = -B;
    Aeq(nx+1:nx+nc, 1:nx) = H*C;
    
    beq(nx+1:end, 1) = r_ref;
    
    cost = @(z) (C*z(1:nx)-y_ref)'*Q_s*(C*z(1:nx)-y_ref) + ...
                z(nx+1:end)'*R_s*z(nx+1:end,1);
            
    Z0 = zeros(nx+nu,1);

    options = optimoptions('fmincon','Display','iter','Algorithm','active-set');
    z_opt = fmincon(cost,Z0,[],[],Aeq,beq,[],[],[],options);
    
    x_s = z_opt(1:nx);
    u_s = z_opt(nx+1:end);
end
